VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Postfix Converter"
   ClientHeight    =   5295
   ClientLeft      =   390
   ClientTop       =   675
   ClientWidth     =   6135
   Icon            =   "Main.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5295
   ScaleWidth      =   6135
   Begin VB.ComboBox cboEnterExp 
      Height          =   315
      Left            =   1440
      TabIndex        =   11
      Top             =   120
      Width           =   4575
   End
   Begin VB.TextBox txtStackState 
      Height          =   3255
      Left            =   3120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   6
      Top             =   1200
      Width           =   2895
   End
   Begin VB.TextBox txtOperations 
      Height          =   3255
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   4
      Top             =   1200
      Width           =   2895
   End
   Begin VB.CommandButton cmdClear 
      Cancel          =   -1  'True
      Caption         =   "&Clear"
      Height          =   375
      Left            =   3120
      TabIndex        =   2
      Top             =   480
      Width           =   2895
   End
   Begin VB.TextBox txtResult 
      Height          =   285
      Left            =   720
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   8
      Top             =   4920
      Width           =   5295
   End
   Begin VB.CommandButton cmdConvert 
      Caption         =   "Convert to &Postfix"
      Default         =   -1  'True
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   2895
   End
   Begin VB.Label lblStackState 
      AutoSize        =   -1  'True
      Caption         =   "&Stack State:"
      Height          =   195
      Left            =   3120
      TabIndex        =   5
      Top             =   960
      Width           =   885
   End
   Begin VB.Label lblNumOfOps 
      Alignment       =   1  'Right Justify
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0"
      Height          =   255
      Left            =   5400
      TabIndex        =   10
      Top             =   4560
      Width           =   615
   End
   Begin VB.Label lblNumOfOpsHeader 
      AutoSize        =   -1  'True
      Caption         =   "Total Number of Operations:"
      Height          =   195
      Left            =   120
      TabIndex        =   9
      Top             =   4590
      Width           =   1995
   End
   Begin VB.Label lblOperations 
      AutoSize        =   -1  'True
      Caption         =   "&Operations Carried Out:"
      Height          =   195
      Left            =   120
      TabIndex        =   3
      Top             =   960
      Width           =   1650
   End
   Begin VB.Label lblResult 
      AutoSize        =   -1  'True
      Caption         =   "&Result:"
      Height          =   195
      Left            =   120
      TabIndex        =   7
      Top             =   4965
      Width           =   495
   End
   Begin VB.Label lblEnterExp 
      AutoSize        =   -1  'True
      Caption         =   "&Enter expression:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   1215
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim OpNum As Integer

Private Sub cmdClear_Click()
    cboEnterExp.Text = ""
    txtResult.Text = ""
    txtOperations.Text = ""
    txtStackState.Text = ""
    lblNumOfOps.Caption = 0
    cboEnterExp.SetFocus
End Sub

Private Sub cmdConvert_Click()
    txtOperations.Text = ""
    lblNumOfOps.Caption = 0
    OpNum = 0
    txtResult.Text = ConvertExpression(cboEnterExp.Text)
    cboEnterExp.AddItem cboEnterExp.Text
    lblNumOfOps.Caption = OpNum
End Sub

Public Function PrecedenceOK(NewElement As String, OldElement As String) As Boolean
    PrecedenceOK = OldElement <> "(" And ((OldElement = "*" Or OldElement = "/") Or _
        ((OldElement = "+" Or OldElement = "-") And (NewElement = "+" Or NewElement = "-")))
End Function

Public Function ConvertExpression(ExpQ As String) As String
    On Error GoTo cancel
    Dim TempElement As String * 1
    Dim Element As String * 1
    Dim OperatorStack As New Collection
    Dim StackState As String
    Dim Continue As Boolean
    Dim ConvExp As String
    While Len(ExpQ) > 0 'Rule ONE - Read Eq. in one pass }
        Element = Left(ExpQ, 1) 'Pop
        txtOperations.Text = txtOperations.Text & "Extracted from input: " & Element & vbCrLf
        OpNum = OpNum + 1
        ExpQ = Right(ExpQ, Len(ExpQ) - 1) 'Cut
        Select Case Element
            Case "+", "-", "*", "/" 'Rule THREE
                Continue = True
                While Continue And OperatorStack.Count > 0
                    TempElement = OperatorStack.Item(OperatorStack.Count) 'Pop
                    txtOperations.Text = txtOperations.Text & "Popped from operator stack: " & TempElement & vbCrLf
                    OpNum = OpNum + 1
                    OperatorStack.Remove (OperatorStack.Count) 'Cut
                    StackState = Left(StackState, Len(StackState) - 1)
                    txtStackState.Text = txtStackState.Text & StackState & vbCrLf
                    If PrecedenceOK(Element, TempElement) Then
                        ConvExp = ConvExp & TempElement & " " 'Rule THREE ai, aii }
                        txtOperations.Text = txtOperations.Text & "Added to result: " & TempElement & vbCrLf
                        OpNum = OpNum + 1
                    Else
                        Continue = False
                        OperatorStack.Add TempElement 'Push
                        txtOperations.Text = txtOperations.Text & "Pushed onto operator stack: " & TempElement & vbCrLf
                        StackState = StackState & TempElement
                        txtStackState.Text = txtStackState.Text & StackState & vbCrLf
                        OpNum = OpNum + 1
                    End If
                Wend
                OperatorStack.Add Element 'Push, Rule THREE b
                StackState = StackState & Element
                txtStackState.Text = txtStackState.Text & StackState & vbCrLf
                txtOperations.Text = txtOperations.Text & "Pushed onto operator stack: " & Element & vbCrLf
                OpNum = OpNum + 1
            Case "(" 'Rule FOUR
                OperatorStack.Add Element
                StackState = StackState & Element
                txtStackState.Text = txtStackState.Text & StackState & vbCrLf
                txtOperations.Text = txtOperations.Text & "Pushed onto operator stack: " & Element & vbCrLf
                OpNum = OpNum + 1
            Case ")" 'Rule FIVE
                Element = OperatorStack.Item(OperatorStack.Count) 'Pop
                StackState = Left(StackState, Len(StackState) - 1)
                txtStackState.Text = txtStackState.Text & StackState & vbCrLf
                txtOperations.Text = txtOperations.Text & "Popped from operator stack: " & Element & vbCrLf
                OpNum = OpNum + 1
                OperatorStack.Remove (OperatorStack.Count) 'Cut
                While Element <> "("
                    ConvExp = ConvExp & Element & " "
                    txtOperations.Text = txtOperations.Text & "Added to result: " & Element & vbCrLf
                    OpNum = OpNum + 1
                    Element = OperatorStack.Item(OperatorStack.Count) 'Pop
                    txtOperations.Text = txtOperations.Text & "Popped from operator stack: " & Element & vbCrLf
                    OpNum = OpNum + 1
                    OperatorStack.Remove (OperatorStack.Count) 'Cut
                    StackState = Left(StackState, Len(StackState) - 1)
                    txtStackState.Text = txtStackState.Text & StackState & vbCrLf
                Wend
            Case " " 'Ignore spaces
            Case Else 'Rule TWO
                ConvExp = ConvExp & Element & " "
                txtOperations.Text = txtOperations.Text & "Added to result: " & Element & vbCrLf
                OpNum = OpNum + 1
        End Select
    Wend
    While OperatorStack.Count > 0 'Rule SIX
        Element = OperatorStack.Item(OperatorStack.Count) 'Pop
        txtOperations.Text = txtOperations.Text & "Popped from operator stack: " & Element & vbCrLf
        OpNum = OpNum + 1
        OperatorStack.Remove (OperatorStack.Count) 'Cut
        StackState = Left(StackState, Len(StackState) - 1)
        txtStackState.Text = txtStackState.Text & StackState & vbCrLf
        ConvExp = ConvExp & Element & " "
        txtOperations.Text = txtOperations.Text & "Added to result: " & Element & vbCrLf
        OpNum = OpNum + 1
    Wend
    Set OperatorStack = Nothing
    ConvertExpression = ConvExp
    Exit Function
cancel:
    MsgBox "Your expression is in error!", vbExclamation, "Error In Expression"
End Function


